//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSetCamNode extends MSBScriptNode;

var MSBActor CameraActor;
var bool ShakyCam;
var Actor LookTarget;
var float FOV;
var bool bDepth;
var bool bLens;
var String LensMaterial;
var int Alpha;
var float flickr;
var PlayerController PC;



function fillSequence()
{
 local MSBAction_SetCamera sC;

 super.fillSequence();

 //create new Action and set our Properties
 PC=Level.GetLocalPlayerController();

 sC=new(none) class'MSBAction_SetCamera';
 sC.pc=PC;
 sC.ViewActor=CameraActor;
 sC.ShakyCam=ShakyCam;
 sC.LookTarget=LookTarget;
 sC.bLens=bLens;
 sC.Alpha=Alpha;
 sC.flickr=flickr;
 if (CameraActor.IsA('MSBCamera'))
   {
   MSBCamera(CameraActor).bDepth=bDepth;
   MSBCamera(CameraActor).bLens=bLens;
   MSBCamera(CameraActor).LensMaterial=LensMaterial;
   if (FOV==0 && MSBCamera(CameraActor).FOV>0)
    FOV=MSBCamera(CameraActor).FOV;
   if (LookTarget!=None)
    {
    CameraActor.SetRotation(rotator(LookTarget.Location-CameraActor.Location));
    CameraActor.initialRotation=rotator(LookTarget.Location-CameraActor.Location);
    }
   }
 sC.FOV=FOV;

 Actions[0]=sC;
}

function execute(string Data)
{
 local MSBDepthOfFieldOverlay over;
 local MSBCamera MSC;

 PC=Level.GetLocalPlayerController();

 if (MSBCamera(CameraActor)!=None)
  {
  MSC=MSBCamera(CameraActor);
  if (LookTarget!=None)
    MSC.SetRotation(rotator(LookTarget.Location-MSC.Location));
  if (FOV>0)
    {
    MSC.FOV=FOV;
    pc.SetFOV(MSC.FOV);
    }
  else
    pc.SetFOV(MSC.FOV);

   MSC.bDepth=bDepth;
   MSC.bLens=bLens;
   MSC.bShaky=ShakyCam;
   Log(MSC.bLens);
  if (LookTarget!=None)
    MSC.ViewTarget=LookTarget;
  }

 pc.SetViewTarget(CameraActor);

 foreach AllActors (class'MSBDepthOfFieldOverlay', over)
   if (Over!=None)
     {
     over.MSC=MSC;
     if (Alpha>0)
       over.Alpha=Alpha;
     if (MSC.bDepth)
       {
       if (flickr>0)
         over.flickr=flickr;
       over.Reset();
       }
     }
}

function Reset()
{
local MSBDepthOfFieldOverlay over;

super.Reset();
if (CameraActor!=None)
  CameraActor.Reset();

foreach AllActors (class'MSBDepthOfFieldOverlay', over)
  if (Over!=None)
    over.Reset();

}

defaultproperties
{
Description="SetCamera"
}

