class MSB3DSpawnButton extends MSBTwoStepButton;

var class <Actor> SpawnActorClass;
var string SpawnActorClassName;

var Actor SpawnActor,
          TraceHitActor;

var () vector DebugLocation;
var float TraceLength;

var vector hitNorm,
           traceExt,
           traceEnd;

var vector moveVector;
var vector xAxis,yAxis,zAxis;

var vector floorOffset;

var EPhysics oldPhysics;

function LeftBtn(Canvas C)
{
super.LeftBtn(C);

if (SpawnActorClass==None)
  SpawnActorClass = class<Actor>(DynamicLoadObject(SpawnActorClassName, class'Class'));

SpawnActor = spawn(SpawnActorClass,,,M.Location,0*M.Rotation);

if (SpawnActor==None)
  M.warningMessage("Creation failed!"@SpawnActorClassName);
else
  {
  if (SpawnActor.IsA('MSBActor'))
    {
    M.LevelActors.Insert(M.LevelActors.Length,1);
    M.LevelActors[M.LevelActors.Length-1]=MSBActor(SpawnActor);
    }
  else if (SpawnActor.IsA('MSBPawn'))
    {
    M.LevelPawns.Insert(M.LevelPawns.Length,1);
    M.LevelPawns[M.LevelPawns.Length-1]=MSBPawn(SpawnActor);
    }
  else
    {
    M.LevelSpecial.Insert(M.LevelSpecial.Length,1);
    M.LevelSpecial[M.LevelSpecial.Length-1]=SpawnActor;
    }
  }


oldPhysics=SpawnActor.Physics;
SpawnActor.SetPhysics(PHYS_None);
Log("Spawning:"@SpawnActor);
M.disableMidLayer();
}

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
SpawnActor.SetPhysics(oldPhysics);
SpawnActor.bCollideWorld=true;
SpawnActor=None;
M.enableMidLayer();
}

function RightBtn(Canvas C)
{
super.RightBtn(C);
if (SpawnActor!=None)
  {
  SpawnActor.Destroy();
  SpawnActor=None;
  }
super.LeftBtnFinished(C);
}

function initButton(Canvas C)
{
local float sY,sZ, fX,fY;
local vector sVec;

super.initButton(C);

C.SetPos(xPos,yPos);
C.SetDrawColor(textCol.R,textCol.G,textCol.B);

if (BtnName!="")
  C.DrawText(BtnName);

C.SetDrawColor(col.R,col.G,col.B);
C.SetPos(xpos,ypos);

if(SpawnActor!=None && M!=None)
 {
  M.GetAxes(M.Rotation,xAxis,yAxis,zAxis);

  //int variables don't divide well
  fX=M.screenX;
  fY=M.screenY;

  //  map ScreenX between -1 and 1
  sY= (Mouse.xPos/fX)*2 -1;
  sZ= (Mouse.yPos/fY) * fY/fX *2 - fY/fX;

  // calculate screenvector
  sVec.Y=sY;
  sVec.X=1;   //distance from eyes to plane is believed 1
  sVec.Z=-sZ; //flip MouseY
  sVec=normal(sVec) * TraceLength;

  traceEnd=sVec;
  //transform with view Coords
  traceEnd=sVec.x * xAxis + sVec.y * yAxis + svec.Z*zAxis;

 //incorporate Player Location
 traceEnd=traceEnd+M.Location;
 TraceHitActor=Trace(debugLocation,hitnorm,traceEnd,M.Location,false,traceExt);
 if (M.bGrid)
   M.calculateGrid(debugLocation);
 SpawnActor.SetLocation(DebugLocation+floorOffset);
 }
}

defaultproperties
{
tooltip1="Spawn 3D"
tooltip2="Place Object"
xpos=20
TraceLength=5000
traceExt=(X=1,Y=1,Z=1)
floorOffset=(X=0,Y=0,Z=0)
col=(R=225,G=225,B=255,A=255)
SpawnActorClassName="Engine.Actor"
}
