class MSBPawnInputControl extends Actor;

var MSBPawn myPawn;

var MSBUdpLink udpLink;
var () int iPort;   // server port number
var bool bUdpInit;

var bool bBlinkAutonomously, bIsBlinking;
var int blinkTime;
var int maxBlinkTime;

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBPawn'))
  myPawn=MSBPawn(Owner);

if (bBlinkAutonomously)
  SetTimer(FRand()*15,false);
}

function initUdp()
{
 iPort=31840+myPawn.UdpPadCh;
 if (udpLink!=None)
   udpLink.Destroy();
 udpLink=Spawn(class'MSBUdpLink',self);
 udpLink.InitUdpLink(iPort);
 Log("UdpPort initialized to"@iPort);
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local rotator HeadTurn;
local int i;

if (Other.IsA('MSBGuiOverlay'))
  {
  initUdp();
  Log("changed UdpPadChannel in MSBPawnInputControl!");
  }

//udp Gamepad_
if (myPawn!=None && myPawn.UdpPadCh>0 && udpLink!=None)
  {
  for (i=4;i<24;i++)
    if (udpLink.byteData[i]>0)
      {
      myPawn.setPawnPose(myPawn.PoseName[i-4]);
      Log("Set Pose to:"@myPawn.PoseName[i-4]);
      }

if(!bIsBlinking)
  {
  myPawn.eyeX=-(udpLink.byteData[0]-128);
  myPawn.eyeY=udpLink.byteData[1]-128;
  myPawn.eyeY*=0.0625;
  myPawn.eyeX*=0.0625;
  //myPawn.browY=udpLink.byteData[1];
  }
else
  {
  if(blinkTime>=maxBlinkTime)
    {
    blinkTime=0;
    bIsBlinking=false;
    SetTimer(FRand()*2+1,false);
    }
  blinkTime++;
  }

  HeadTurn.Yaw=32*(udpLink.byteData[3]-127);
  HeadTurn.Roll=-32*(udpLink.byteData[2]-127);
  if (VSize(vector(HeadTurn))>0)
    {
    myPawn.SetBoneRotation('Bip01 Head',HeadTurn);
    }
  }
}

event Destroyed()
{
udpLink.Destroy();
}

event Timer()
{
bIsBlinking=true;
myPawn.eyeX=16;
myPawn.eyeY=16;
}

defaultproperties
{
DrawType=DT_None
iPort=31840
bBlinkAutonomously=true
maxBlinkTime=1
}
