//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSceneEditorHud extends MSBHud;

var bool DrawMidLayer;
var bool bOut;
var Material MidLayer;

function PostRender(Canvas C)
{
local int i;
super.PostRender(C);
//-------------------------------------------------
// Editing Mode - drawing Nodes on Hud
//-------------------------------------------------
if (DrawOverlays)
  {
// check DepthOfFieldstuff
  if (dofOverlay.bReady)
    dofOverlay.disableOverlays();

// first first, draw the transparent grey Layer
  if (DrawMidLayer)
    {
    C.SetPos(0,0);
    C.SetDrawColor(128,128,128,128);
    C.DrawTile(MidLayer,C.ClipX,C.ClipX,0,0,16,16);
    }

// first draw the MainMenu
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBGuiOverlay') &&  MSBGuiOverlay(Overlays[i]).bMainMenu)
        Overlays[i].Render(C);

// then draw Nodes
    for (i = 0; i < Overlays.length; i++)
       if (Overlays[i].IsA('MSBNodeButton') && !MSBNodeButton(Overlays[i]).bContained)
          Overlays[i].Render(C);

// Noe In/Out drawing order

if (bOut)
  {
// then draw the NodeIns
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBNodeInButton'))
        Overlays[i].Render(C);

// then draw the NodeOuts
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBNodeOutButton'))
        Overlays[i].Render(C);
  }
else
  {
// then draw the NodeOuts
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBNodeOutButton'))
        Overlays[i].Render(C);

// then draw the NodeIns
    for (i = 0; i < Overlays.length; i++)
      if (Overlays[i].IsA('MSBNodeInButton'))
        Overlays[i].Render(C);
   }

//then draw the rest
    for (i = 0; i < Overlays.length; i++)
      {
      if (!Overlays[i].isA('MSBGuiOverlay') && !MSBGUIOverlay(Overlays[i]).bContained)
          Overlays[i].Render(C);
      else if (!Overlays[i].IsA('MSBNodeButton') && !MSBGuiOverlay(Overlays[i]).bMainMenu && !MSBGUIOverlay(Overlays[i]).bContained)
        Overlays[i].Render(C);
      }
//if viewed from another actor, reset viewtarget
  if (M.ViewTarget!=M && !M.IsInState('MoveObject'))
     {
     M.Reset();
     M.GotoState('MSBCode');
     }
  }

//-----------------------------------------------------------------
// Run Mode - draw only permanent Overlays and DepthOfField stuff
//----------------------------------------------------------------
else
  {
// Render permanent Buttonoverlays
  for (i = 0; i < Overlays.length; i++)
    if (MSBGuiOverlay(Overlays[i]).bPermanent)
      Overlays[i].Render(C);
// Render User Overlays
  for (i=0;i<UserOverlays.length;i++)
    if (UserOverlays[i].Tex!=None)
      {
      UserOverlays[i].Render(C);
      }
//Render DepthOfField
  if (M.ViewTarget.IsA('MSBCamera') && MSBCamera(M.ViewTarget).bDepth)
     {
     dofOverlay.MSC=MSBCamera(M.ViewTarget);
     if (!dofOverlay.bReady)
       dofOverlay.iniOverlays();
     dofOverlay.Render(C);
     }
  }
}

DefaultProperties
{
MenuButtons(0)="MSBCode.MSBNaviButton";
MenuButtons(1)="MSBCode.MSBMenuButtonActor";
MenuButtons(2)="MSBCode.MSBMenuButtonStatic";
MenuButtons(3)="MSBCode.MSBMenuButtonNodes";
MenuButtons(4)="MSBWidgetPen.MSBPenWidget";
MenuButtons(5)="MSBWidgetPose.MSBPoseWidget"
MenuButtons(6)="MSBWidgetFilters.MSBFiltersWidget"
MenuButtons(7)="MSBCode.MSBMenuButtonSystem";
MenuButtons(8)="MSBCode.MSBMiniMap";
MidLayer=Texture'MoviesandboxTextures.icon_node'
DrawMidLayer=true
bStartMenu=true
}
