//-----------------------------------------------------------
//  A ListButton Spawns a number of SubButtons
//  just like in a Menu.
//  Once another Button is triggered, the Menu is being removed.
//
//  Copyright 2005 Friedrich Kirschner
//-----------------------------------------------------------
class MSBListButton extends MSBGuiOverlay
config(MSBButtonConfig);

var config array<String> ButtonList;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;

//Buttonlist page system:
var int lastpage,maxButtons,maxListSize,currentpage, additionalButtons;

var int listOrientation;                             //1=left
                                                     //2=bottom
                                                     //3=right
                                                     //4=top

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i,currentListSize;
super.LeftBtn(C);

if ((currentpage+1)*maxListSize<=Buttonlist.length + additionalButtons)
  maxButtons=(currentpage+1)*maxListSize;
else
  maxButtons=Buttonlist.length + additionalButtons;

// revisit button distribution...
for (i=currentpage*maxListSize;i<maxButtons; i++)
  {
  if (ButtonList[i]!="" && ButtonList[i]!="None")
    {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[i]=Spawn(ButtonClass,self,,M.Location);
    ListButton[i].SubLevel=SubLevel+1;
    currentListSize++;
    }
  }

for (i=0;i<ListButton.length;i++)
  if (ListButton[i]!=None)
    positionButton(C,i,xposRel,yPosRel);

i=currentpage*maxListsize+currentListSize;

if (Buttonlist.length>maxListSize)
  {
  createSwitchButtons(i);
  positionSwitchButtons(i);
  }
}

function createSwitchButtons(out int i)
{
ListButton[i]=Spawn(class'MSBPropertyButtonSlider',self,,M.Location);
MSBNextPageButton(ListButton[i]).Parent=self;
ListButton[i].SubLevel=SubLevel+1;
}

function createSwitchButtonsOld(out int i)
{
//create next/prev page buttons
ListButton[i]=Spawn(class'MSBNextPageButton',self,,M.Location);
MSBNextPageButton(ListButton[i]).Parent=self;
ListButton[i].SubLevel=SubLevel+1;

ListButton[++i]=Spawn(class'MSBPrevPageButton',self,,M.Location);
MSBPrevPageButton(ListButton[i]).Parent=self;
ListButton[i].SubLevel=SubLevel+1;
}

function positionSwitchButtonsOld(int i)
{
local MSBPrevPageButton prev;
local MSBNextPageButton next;
local MSBGuiOverlay last;

next=MSBNextPageButton(ListButton[i-1]);
prev=MSBPrevPageButton(ListButton[i]);
last=ListButton[i-2];

if(listOrientation==1)
  {
  prev.xPos=xPos+width;
  next.xPos=prev.xPos+prev.width;
  prev.yPos=last.yPos+prev.height;
  next.yPos=prev.yPos;
  }
}

function positionButton(Canvas C, int i, optional float x, optional float y)
{
if(listOrientation==1)
  positionButtonLeft(C,i,xPos,yPos);

if(listOrientation==2)
  positionButtonBottom(C,i,xPos,yPos);
}

function positionButtonLeft(Canvas C,int i, optional float x, optional float y)
{
if (ListButton[i].height<60)
  ListButton[i].xPos=x+width;
else
  {
  ListButton[i].xPos=x-16 -2*width;
  if (Listbutton[i].xPos<C.ClipX)
    ListButton[i].xPos=x+16+2*width;
  }

if (i>currentpage*maxListSize)
  {
  if (i>0)                      //horizontal alignment
    ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
    {
    ListButton[i].ypos=y-(i*ListButton[i].height+height+1);
    }
  }
else
  ListButton[i].yPos=y;
}

function positionButtonBottom(Canvas C,int i, optional float x, optional float y)
{
ListButton[i].xPos=x;

if (i>0)                      //vertical alignment
  ListButton[i].yPos=ListButton[i-1].ypos-(ListButton[i].height+1);
else
  ListButton[i].yPos=y-(ListButton[i].height+1);
}


DefaultProperties
{
tooltip="Click for more Options"
maxListSize=10
listOrientation=1
}
