class MSBActor extends Actor;

var array<String> ButtonList;
var array<String> Properties;
var array<String> ButtonMat;
var vector initialLocation;
var rotator initialRotation;
var EPhysics oldPhysics;
var Actor AttachedTo;
var string content;
var array<MSBKeyFrame> Keys;

var bool bDisplayed;  //seperates the control objects from the props

//Every Actor can be controlled by an Input device sending data to its channel
var bool bInputControlled;
var string InputControlClassName;
var Actor MSBInputControl;
var int UdpPadCh;

var EDrawType oldDrawType;

function initialize();

function LoadProp()
{
local Material newTex;

newTex=Material(DynamicLoadObject(content, class'Material'));
if (newTex!=None)
  {
  SetDrawType(DT_Sprite);
  oldDrawType=DT_Sprite;
  Texture=newTex;
  }
SetStaticMesh(StaticMesh(DynamicLoadObject(content, class'StaticMesh')));
if (StaticMesh!=None)
  {
  Skins.Remove(0,Skins.length);
  SetDrawType(DT_StaticMesh);
  oldDrawType=DT_StaticMesh;
  }
Log("Loading content:"@content);
}

//for attachment Loading

function setAttachment()
{
if(AttachedTo!=None)
  {
    if(Tag=='lhand')
        AttachedTo.AttachToBone(self,'Bip01 L Hand');
    else if (Tag=='rhand')
      AttachedTo.AttachToBone(self,'Bip01 R Hand');
    else if (Tag=='head')
      AttachedTo.AttachToBone(self,'Bip01 Head');
    else if (Tag=='spine1')
      AttachedTo.AttachToBone(self,'bip01 Spine1');
    else if (Tag=='only')
      AttachedTo.AttachToBone(self,'');
  }
}

//currently used for MSBMasterBlocks
//TODO: make this work for ActorWrapper too!
function releaseAttachment();

function RunMovie()
{
if (!bDisplayed)
  {
  oldDrawType=DrawType;
  SetDrawType(DT_None);
  }
oldPhysics=Physics;
initialLocation=Location;
initialRotation=Rotation;
// Log("MSActor->RunMovie->Location:"@name@initialLocation);
}

function StopMovie();

function Reset()
{
super.Reset();
if (attachedTo==None)
  {
  SetPhysics(PHYS_None);
  SetLocation(initialLocation);
  SetRotation(initialRotation);
  SetPhysics(oldPhysics);
  }
SetDrawType(oldDrawType);
}

function clearActor();

function SetDebug();

function Trigger(Actor Other, Pawn EventInstigator)
{
super.Trigger(Other, EventInstigator);
if (Other.isA('MSBGuiOverlay') && MSBInputControl!=None)
  {
  MSBInputControl.Trigger(Other,EventInstigator);
  }
}


defaultproperties
{
Skins(0)=Material'MovieSandboxTextures.white'

ButtonList(0)="MSBPropertyButtons.MSBPropertyButtonMove"
Properties(0)="Dummy"
ButtonMat(0)="MoviesandboxTextures.icon_move"

ButtonList(1)="MSBPropertyButtons.MSBPropertyButtonRotate"
Properties(1)="Dummy"
ButtonMat(1)="MoviesandboxTextures.icon_rotate"

ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonScale"
Properties(2)="Dummy"
ButtonMat(2)="MoviesandboxTextures.icon_size"

ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonCreateKeyFrame"
Properties(3)="Dummy"
ButtonMat(3)="MoviesandboxTextures.icon_key"

ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonAdvancedProps"
Properties(4)="Dummy"
ButtonMat(4)="MoviesandboxTextures.icon_advanced"

bDisplayed=true

bStatic=false
bNoDelete=false
bHidden=false
bMovable=true

bDirectional=True

//CollisionRadius=16.0
//CollisionHeight=16.0

bUseCylinderCollision=false
bUseCollisionStaticMesh=true
bCollideActors=True
bBlockActors=False
bCollideWorld=True
bProjTarget=True
bBlockPlayers=false
Texture=S_Actor
}
