// ***************************************************************************************
// this is the actor whose view gets rendered.
// Applies own view as texture so rendering works fine
// Also serves as Renderer for the ScriptedTexture set in MSBDepthOfFieldOverlay
//
// relLocation determins position from Actual Camera and is calculated in MSBDepthOfFieldOverlay.
// ***************************************************************************************
class MSBCamTexClientDoF extends Actor
config (MSBCode);

var Actor CameraActor;
var int FOV;
var vector relLocation;
var ScriptedTexture Tex;
var config float frequency;

event PostBeginPlay()
{
super.PostBeginPlay();
//SetTimer(1/frequency,true);
SaveConfig();
}

event Timer()
{
Tex.Revision++;
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);
SetLocation(CameraActor.Location+relLocation);
//Tex.Revision++;
}

simulated event RenderTexture(ScriptedTexture Tex)
{
Tex.DrawPortal(0,0,Tex.uSize,Tex.VSize,CameraActor,CameraActor.location+relLocation,Rotation,FOV,false);
}

defaultproperties
{
FOV=90;

bNoDelete=false;
bStatic=false;
StaticMesh=StaticMesh'TowerStatic.TowerStoneC'
DrawType=DT_StaticMesh

DrawScale=0.01

frequency=15
}
