#exec OBJ LOAD FILE=MovieSandboxMeshes.usx

class MSBCamera extends MSBActor;

//internal
var PlayerController PC;

//shakycamera
var bool bShaky;
var int maxXShake;
var int maxYShake;
var int maxZShake;

//Camera Properties
var Actor ViewTarget;
var bool lazyCam;
var int FOV;

var rotator BaseRotation;
var rotator maxRot;


var bool bDepth;
var bool bLens;
var string LensMaterial;

function PostBeginPlay()
{
super.PostBeginPlay();
Enable('Tick');
PC=Level.GetLocalPlayerController();
}

function LoadProp();

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);

 if (PC.ViewTarget==self)
   {
   //set FOV
   if (PC!=None)
    {
    PC.DefaultFOV=FOV;
    PC.DesiredFOV=FOV;
    }
   //set ViewTarget
   if (ViewTarget!=None && MSBInputControl==None)
     SetRotation(rotator(ViewTarget.Location - self.Location));
   //set CameraShake
   if (bShaky)
     ShakeCamera();
   }
}

function ShakeCamera();

function Reset()
{
super.Reset();
BaseRotation=Rotation;
ViewTarget=None;
bShaky=false;
lazyCam=false;
}

defaultproperties
{
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(3)="UdpPadCh"
ButtonMat(3)="MoviesandboxTextures.icon_puppet"
//for WiiMote Roll - tbd
//ButtonList(9)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(9)="UdpHeadPadCh"

ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonPossess"
Properties(5)="Possess"
ButtonMat(5)="MoviesandboxTextures.icon_selectChar"

ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(6)="FOV"
ButtonMat(6)="MoviesandboxTextures.icon_fov"

ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonAttachToBone"
Properties(7)="Dummy"
ButtonMat(7)="MoviesandboxTextures.icon_attach"

FOV=90

lazyCam=false
bHidden=false
bStatic=False

bDisplayed=false

maxXShake=10;
maxYShake=-10;
maxZShake=12;

Physics=PHYS_None
bDirectional=True
CollisionRadius=24.0
CollisionHeight=16.0
bUseCylinderCollision=true
bCollideActors=True
bBlockActors=False
bCollideWorld=False
bProjTarget=True

DrawType=DT_StaticMesh
StaticMesh=StaticMesh'MovieSandBoxMeshes.helperMeshes.CameraBody'
Skins(0)=Material'MovieSandboxTextures.lightBlue'
DrawScale=0.5
AmbientGlow=100
content="MovieSandboxMeshes.helperMeshes.CameraBody"

bInputControlled=true;
InputControlClassName="MSBObjects.MSBGametrakInputControl";
}
