class MSBInterpolationHelper extends Actor;

var MSBActor Parent;
var Actor Target;
var int keyNum;

//Posing and Rotation Vars
var MSBAniKey BaseKey;
var MSBAniKey TargetKey;
var MSBPawn MSP;

var rotator BaseRotation;
var rotator TargetRotation;

//timing
var float blendTime;
var float currentTime;


//Value Vars
var float BaseValue;
var float TargetValue;

//internal
var float Value;
var float changeAmount;
var float Alpha;

var bool bLocationTween, bRotationTween, bPoseTween, bJustSpawned, bInit;

//Spline related stuff
var Spline splMove, splRotate;

//Movement
var float passedTime, moveTime, partTime, distance;
var vector startVel, endVel;  //path Velocities at turning point and at start/end

//Rotation
var float passRotTime, rotateTime, partRotTime, degrees;
var rotator startVelRot, endVelRot;

//KeyFrames
var int currentKey;
var int currentKeyRot;

//******************************************************************************
// initializing
//******************************************************************************
function PostBeginPlay()
{
super.PostBeginPlay();
if (Owner!=None)
  Parent=MSBActor(Owner);
bJustSpawned=true;
}

function initializePoseTween()
{

bPoseTween=true;

MSP=MSBPawn(TargetKey.KeyActor);
if (MSP.PoseKey[TargetKey.BoneNumber]==None)
  MSP.iniPosing();

BaseKey=MSP.PoseKey[TargetKey.BoneNumber];
BaseRotation=MSP.PoseKey[TargetKey.BoneNumber].BoneRotation;
TargetRotation=TargetKey.BoneRotation;

splRotate=new class'Spline';
splRotate.InitSplineRot(0,BaseRotation,startVelRot,BlendTime,TargetRotation,endVelRot);
//ToDo: Make this stuff work...
if (VSize(TargetKey.OriginOffset)!=0)
  {
  splMove=new class'Spline';
  splMove.InitSplinePath(0,BaseKey.OriginOffset,startVel,BlendTime,TargetKey.OriginOffset,endVel);
  }
bJustSpawned=false;
}

function initializeLocationTween()
{
local int i;

//Measure overall Distance of Spline
if (Parent.Keys.length>1)
  {
  distance=VSize(Parent.Keys[0].Location-Parent.Location);
  for (i=0;i<Parent.Keys.Length-1;i++)
    distance+=VSize(Parent.Keys[i+1].Location-Parent.Keys[i].Location);
  }

//switch between KeyFrame Handling and simple Tween
if (Parent.Keys.length>1)
  reInitSplineMove();
else
  {
  partTime=moveTime;
  splMove=new class'Spline';
  splMove.InitSplinePath(0,Parent.Location,startVel,moveTime,Target.Location,endVel);
  }
bJustSpawned=false;
bLocationTween=true;
}

function initializeRotationTween()
{
local int i;

//Measure overall Distance of Rotation
if (Parent.Keys.length>1)
  {
  if (VSize(vector(Parent.Rotation)-vector(Parent.Keys[0].Rotation))>VSize(vector(Parent.Keys[0].Rotation)-vector(Parent.Rotation)))
    degrees=VSize(vector(Parent.Keys[0].Rotation)-vector(Parent.Rotation));
  else
    degrees=VSize(vector(Parent.Rotation)-vector(Parent.Keys[0].Rotation));

  for (i=0;i<Parent.Keys.Length-1;i++)
    {
    if (VSize(vector(Parent.Keys[i+1].Rotation)-vector(Parent.Keys[1].Rotation))>VSize(vector(Parent.Keys[i].Rotation)-vector(Parent.Keys[i+1].Rotation)))
      degrees+=VSize(vector(Parent.Keys[i].Rotation)-vector(Parent.Keys[i+1].Rotation));
    else
      degrees+=VSize(vector(Parent.Keys[i+1].Rotation)-vector(Parent.Keys[i].Rotation));
    }
  }
//switch between KeyFrame Handling and simple Tween
if (Parent.Keys.length>1)
  reInitSplineRotate();
else
  {
  partRotTime=rotateTime;
  splRotate=new class'Spline';
  splRotate.InitSplineRot(0,Parent.Rotation,startVelRot,partRotTime,Target.Rotation,endVelRot);
  }
bJustSpawned=false;
bRotationTween=true;
}

//******************************************************************************
// Tick
//******************************************************************************
function Tick(float DeltaTime)
{
  if (!bJustSpawned && !bPoseTween && !bLocationTween && !bRotationTween)
    Destroy();
  if (bPoseTween)
    {
    TweenPoseKey(DeltaTime);
    if (VSize(TargetKey.OriginOffset)!=0)
      TweenOrigin(DeltaTime);
    }
  if (bLocationTween)
    TweenLocation(DeltaTime);

  if (bRotationTween)
    TweenRotation(DeltaTime);
}


//******************************************************************************
// Rotation Tweening
//******************************************************************************
function TweenRotation(float DeltaTime)
{
local rotator myRot, myAccel, mySpeed;
local float myDT;

if (splRotate.mTime<partRotTime-2*deltaTime)
  {
  splRotate.NextSplineRot(DeltaTime,myRot,mySpeed,myAccel,myDT);
  Parent.SetRotation(myRot);
  }
else
  {
  if (Parent.Keys.Length>currentkeyRot)
    reInitSplineRotate();
  else
    bRotationTween=false;
  }

}

function reInitSplineRotate()
{
local rotator oldEndRot;
local vector thisOrientation, nextOrientation;
local float speed, partDegrees;

oldEndRot=endVelRot;
Target=Parent.Keys[currentkeyRot];

//Time and Distance
if (VSize(vector(Parent.Keys[currentkeyRot].Rotation)-vector(Parent.Rotation))<VSize(vector(Parent.Rotation)-vector(Parent.Keys[currentkeyRot].Rotation)))
  partDegrees=VSize(vector(Target.Rotation)-vector(Parent.Rotation));
else
  partDegrees=VSize(vector(Parent.Rotation)-vector(Target.Rotation));

//kinda hackish
partRotTime=RotateTime/Degrees * partDegrees;

partRotTime=RotateTime/Parent.Keys.Length;

speed=Degrees/RotateTime;
Log(Speed);

//Orientation
if (currentKeyRot<Parent.Keys.Length-1)
  {
  if (VSize(vector(Parent.Keys[currentkeyRot].Rotation))-VSize(vector(Parent.Keys[currentkeyRot+1].Rotation)) > VSize(vector(Parent.Keys[currentkeyRot+1].Rotation))-VSize(vector(Parent.Keys[currentkeyRot].Rotation)))
    nextOrientation=Normal(vector(Parent.Keys[currentkeyRot].Rotation)-vector(Parent.Keys[currentkeyRot+1].Rotation));
  else
    nextOrientation=Normal(vector(Parent.Keys[currentkeyRot+1].Rotation)-vector(Parent.Keys[currentkeyRot].Rotation));
  }
if (VSize(vector(Parent.Keys[currentkeyRot].Rotation))-VSize(vector(Parent.Rotation)) > VSize(vector(Parent.Rotation))-VSize(vector(Parent.Keys[currentkeyRot].Rotation)))
  thisOrientation=Normal(vector(Parent.Keys[currentkeyRot].Rotation)-vector(Parent.Rotation));
else
  thisOrientation=Normal(vector(Parent.Rotation)-vector(Parent.Keys[currentkeyRot].Rotation));

//start and end velocities
if (currentKey==Parent.Keys.Length-1)
  endVelRot=0*endVelRot;
else
  endVelRot=rotator(normal(nextOrientation))*speed;

//determine start Velocity
if (currentKeyRot==0)
  startVelRot=0*oldEndRot;
else
  startVelRot=oldEndRot;

splRotate=new class'Spline';
splRotate.InitSplineRot(0,Parent.rotation,startVelRot,partRotTime,Target.rotation,endVelRot);
currentKeyRot++;
}

//******************************************************************************
// Location Tweening
//******************************************************************************
function TweenLocation(float DeltaTime)
{
local vector myLoc, myAccel, mySpeed;
local float myDT;

if (splMove.mTime<partTime-deltaTime)
  {
  splMove.NextSplinePos(deltaTime,myLoc,mySpeed,myAccel,myDT,true,true);
  passedTime+=DeltaTime;
  Parent.Velocity=mySpeed*myDT/moveTime;
  if (VSize(myLoc)!=0)
    Parent.SetLocation(myLoc);
//Log("Speed:"@mySpeed@"startVel"@startVel@"endVel:"@endVel);
  }
else
  {
  if (Parent.Keys.Length>currentkey)
    reInitSplineMove();
  else
    bLocationTween=false;
  }
}

function reInitSplineMove()
{
local vector oldEnd, thisOrientation, nextOrientation;
local float speed, partDistance;

oldEnd=endVel;
Target=Parent.Keys[currentkey];

//Time and Distance
partDistance=VSize(Parent.Keys[currentkey].Location-Parent.Location);
partTime=moveTime/distance * partDistance;
speed=distance/moveTime;

//Orientation
if (currentKey<Parent.Keys.Length-1)
  nextOrientation=Parent.Keys[currentkey+1].Location-Parent.Keys[currentKey].Location;
thisOrientation=Parent.Keys[currentkey].Location-Parent.Location;

//start and end velocities
if (currentKey==Parent.Keys.Length-1)
  endVel=0*endVel;
else
  endVel=normal(nextOrientation+thisOrientation)*speed;

//determine start Velocity
startVel=normal(oldEnd)*speed;

splMove=new class'Spline';
splMove.InitSplinePath(0,Parent.Location,startVel,partTime,Target.Location,endVel);
currentKey++;
}

//******************************************************************************
// PoseKey Tweening
//******************************************************************************
function TweenPoseKey(float DeltaTime)
{
local rotator myRot, myAccel, mySpeed;
local float myDT;

if (splRotate.mTime<BlendTime-2*deltaTime)
  {
  splRotate.NextSplineRot(DeltaTime,myRot,mySpeed,myAccel,myDT);
  BaseKey.BoneRotation=myRot;
  BaseKey.changeBoneRotation();
  }
else
  {
  BaseKey.BoneRotation=TargetRotation;
  BaseKey.changeBoneRotation();
  bPoseTween=false;
  }
}

function TweenOrigin(float DeltaTime)
{
local vector myMov, myAccel, mySpeed;
local float myDT;

if (splMove.mTime<BlendTime-2*deltaTime)
  {
  splMove.NextSplinePos(DeltaTime,myMov,mySpeed,myAccel,myDT);
  BaseKey.OriginOffset=myMov;
  BaseKey.changeBoneLocation();
  }
else
  {
  BaseKey.OriginOffset=TargetKey.OriginOffset;
  BaseKey.changeBoneLocation();
  }
}
//******************************************************************************
defaultproperties
{
     bStatic=False
     bHidden=true
     bNodelete=False
     RemoteRole=ROLE_SimulatedProxy
     blendTime=1
}
