class MSBMasterBlock extends MSBActor
config(MSBCode);

var name attachBoneName;
var MSBEmitter E;
var Actor P;
var int BoneNumber;
var int blockamount;
var vector edScale;
var bool bFaceBlock;
var bool bCalcLighting;
var bool bStopMotion;
var () float stepTime, stepVar, stepConst;
var float dTime;
var string method;
var config float loadTimeOut;

//HACK for Dresden
var bool bRotaty;

//make sure we have a reference to P
//P=self if we are just a drawing
//P=Pawn if we're part of a VoxelCharacter

function PostBeginPlay()
{
super.PostBeginPlay();
if (Owner!=None)
  P=Owner;
}

//disable collision so that we don't block characters
function RunMovie()
{
super.RunMovie();
Log("Our Owner is a:"@P@"*************************************");
if(!P.IsA('MSBPawn') && !P.IsA('MSBRagdoll'))
  SetCollision(true,false,false);
else
  SetCollision(false,false,false);
SetDrawType(DT_None);
}

//reset Collision so that mouse finds us
function StopMovie()
{
super.StopMovie();

if(P==None || (!P.IsA('MSBPawn') && !P.IsA('MSBRagdoll')))
  {
  SetCollision(true,false,false);
  SetDrawType(DT_StaticMesh);
  }
}


//used to manually update to Bone Position/Rotation
//TODO: largely inflated - needs trimming!
function Tick(float DeltaTime)
{
local vector BoneLoc;
local Rotator BoneRot;
local Light L;
local float ldist;
local int i;
local float x,y,z;
local vector proNorm;

//HACK for Dresden
if(bRotaty && Tag=='fwd')
  SetRotation(Rotation+rot(0,0,100));
if(bRotaty && Tag=='rew')
  SetRotation(Rotation-rot(0,0,100));

if(bRotaty && Tag=='rumpel')
  SetLocation(initialLocation+FRand()*vect(5,0,0)+FRand()*vect(0,5,0)+FRand()*vect(0,0,5));


if (E!=None)
  if(bHidden)
    E.bHidden=true;
  else
    E.bHidden=false;

dTime+=DeltaTime;
if (dTime>10)
  dTime=0;

stepTime=stepConst+ FRand()*FRand()*stepVar;
//HACK: projection stuff
x=FRand();
y=FRand();
z=FRand();
proNorm.x=x;
proNorm.Y=y;
proNorm.Z=z;
if (E!=None && E.P!=None)
  SpriteEmitter(E.P).ProjectionNormal=proNorm;

//ToDO: this needs some optimisation!!!!
if (!bFaceBlock && P!=None && !P.IsA('MSBActor'))
 {
 getBoneVector(BoneNumber, BoneLoc, BoneRot);

 //this is here for special animation look!
  if (P.IsA('MSBRagdoll'))
    {
    if (dTime>=stepTime)
      {
      SetLocation(boneLoc+RelativeLocation);
      SetRotation(boneRot+RelativeRotation);
      }
    }
  else
    {
    SetLocation(boneLoc+RelativeLocation);
    SetRotation(boneRot+RelativeRotation);
    }
  if (E!=None)  //take our drawing with us
    {
    E.SetLocation(boneLoc+RelativeLocation);
    E.SetRotation(boneRot+RelativeRotation);
    }
  dTime=0;
 }

if (bFaceBlock && E!=None)
  {
  E.SetLocation(Location+RelativeLocation);
  E.SetRotation(Rotation+RelativeRotation);
  }

if(bCalcLighting && E!=None)
  {
  foreach AllActors (class'Light',L)
    if(L!=None)
      {
//      Log((L.LightBrightness/255)*ldist);
      for(i=0;i<E.P.Particles.Length;i++)
        {
        ldist=VSize(L.Location-(Location+E.P.Particles[i].Location));
        ldist=L.LightRadius/ldist;
        E.P.Particles[i].ColorMultiplier.X=(L.LightBrightness/255)*ldist;
        E.P.Particles[i].ColorMultiplier.Y=(L.LightBrightness/255)*ldist;
        E.P.Particles[i].ColorMultiplier.Z=(L.LightBrightness/255)*ldist;
        }
      break;
      }
  }
}

//get rid of our content here
function clearBlocks()
{
if(E!=None)
  E.Destroy();
}

//************************************************************
// integrated functions to modify the Emitter
//***********************************************************
//needs work, doesn't work right now
function setScale(float myScale, int p)
{
E.P.Particles[p].StartSize.X=myScale;
}

function scaleMe(float chgScale)
{
local int i;

if (E!=None)
  for(i=0;i<E.P.Particles.Length;i++)
    {
    E.P.Particles[i].Location+=chgScale*E.P.Particles[i].Location;
    E.P.Particles[i].StartSize.X+=chgScale*E.P.Particles[i].StartSize.X;
    E.P.Particles[i].StartSize.Y+=chgScale*E.P.Particles[i].StartSize.Y;
    E.P.Particles[i].StartSize.Z+=chgScale*E.P.Particles[i].StartSize.Z;
    }
}

function setColor(color c, int p)
{
local vector vec;
vec.x=c.R;
vec.y=c.G;
vec.z=c.B;
E.P.Particles[p].ColorMultiplier=vec/255;
}

function setParticleLocation(vector v,int p)
{
E.P.Particles[p].Location=v;
}

//****************************************************
//Attachments
function setAttachment()
{
if(AttachedTo!=None && E!=None)
  {
    Log("******************** We should attach this now!");

    if(Tag=='lhand')
      AttachedTo.AttachToBone(E,'Bip01 L Hand');
    else if (Tag=='rhand')
      AttachedTo.AttachToBone(E,'Bip01 R Hand');
    else if (Tag=='head')
      AttachedTo.AttachToBone(E,'Bip01 Head');
    else if (Tag=='spine1')
      AttachedTo.AttachToBone(E,'bip01 Spine1');
    else if (Tag=='only')
      AttachedTo.AttachToBone(E,'');
  }
}

function releaseAttachment()
{
  AttachToBone(E,'');
  E.SetRelativeLocation(0*Location);
  E.SetRelativeRotation(0*Rotation);
  Tag=name;
}

//manually set UT bonestructure (because of the spaces in the bonenames...)
function getBoneVector(int BoneNumber, out vector boneLoc, out rotator BoneRot)
{
switch (BoneNumber)
 {
 case 0:
   boneLoc=P.GetBoneCoords('Bip01').Origin;
   boneRot=P.GetBoneRotation('Bip01');
   break;
 case 1:
   boneLoc=P.GetBoneCoords('Bip01 Pelvis').Origin;
   boneRot=P.GetBoneRotation('Bip01 Pelvis');
   break;
 case 2:
   boneLoc=P.GetBoneCoords('bip01 Spine').Origin;
   boneRot=P.GetBoneRotation('bip01 Spine');
   break;
 case 3:
   boneLoc=P.GetBoneCoords('bip01 Spine1').Origin;
   boneRot=P.GetBoneRotation('bip01 Spine1');
   break;
 case 4:
   boneLoc=P.GetBoneCoords('bip01 Spine2').Origin;
   boneRot=P.GetBoneRotation('bip01 Spine2');
   break;
 case 5:
   boneLoc=P.GetBoneCoords('Bip01 Neck').Origin;
   boneRot=P.GetBoneRotation('Bip01 Neck');
   break;
 case 6:
   boneLoc=P.GetBoneCoords('Bip01 R Clavicle').Origin;
   boneRot=P.GetBoneRotation('Bip01 R Clavicle');
   break;
 case 7:
   boneLoc=P.GetBoneCoords('Bip01 R UpperArm').Origin;
   boneRot=P.GetBoneRotation('Bip01 R UpperArm');
   break;
 case 8:
   boneLoc=P.GetBoneCoords('Bip01 R Forearm').Origin;
   boneRot=P.GetBoneRotation('Bip01 R Forearm');
   break;
 case 9:
   boneLoc=P.GetBoneCoords('Bip01 R Hand').Origin;
   boneRot=P.GetBoneRotation('Bip01 R Hand');
   break;
 case 10:
   boneLoc=P.GetBoneCoords('Bip01 R Finger').Origin;
//   boneRot=P.GetBoneRotation('Bip01 R Finger');
   break;
 case 11:
   boneLoc=P.GetBoneCoords('Bone_weapon').Origin;
   boneRot=P.GetBoneRotation('Bone_weapon');
   break;
 case 12:
  boneLoc=P.GetBoneCoords('Bip01 L Clavicle').Origin;
  boneRot=P.GetBoneRotation('Bip01 L Clavicle');
   break;
 case 13:
  BoneLoc=P.GetBoneCoords('Bip01 L UpperArm').Origin;
  boneRot=P.GetBoneRotation('Bip01 L UpperArm');
   break;
 case 14:
  boneLoc=P.GetBoneCoords('Bip01 L Forearm').Origin;
  boneRot=P.GetBoneRotation('Bip01 L Forearm');
   break;
 case 15:
  boneLoc=P.GetBoneCoords('Bip01 L Hand').Origin;
  boneRot=P.GetBoneRotation('Bip01 L Hand');
   break;
 case 16:
  boneLoc=P.GetBoneCoords('Bip01 L Finger').Origin;
//  boneRot=P.GetBoneRotation('Bip01 L Finger');
   break;

 case 17:
  boneLoc=P.GetBoneCoords('bip01 R Thigh').Origin;
  boneRot=P.GetBoneRotation('bip01 R Thigh');
   break;
 case 18:
  boneLoc=P.GetBoneCoords('Bip01 R Calf').Origin;
  boneRot=P.GetBoneRotation('Bip01 R Calf');
   break;
 case 19:

  boneLoc=P.GetBoneCoords('Bip01 R Foot').Origin;
  boneRot=P.GetBoneRotation('Bip01 R Foot');
   break;
 case 20:
  boneLoc=P.GetBoneCoords('Bip01 R Toe0').Origin;
  boneRot=P.GetBoneRotation('Bip01 R Toe0');
   break;

 case 21:
  boneLoc=P.GetBoneCoords('bip01 L Thigh').Origin;
  boneRot=P.GetBoneRotation('bip01 L Thigh');
   break;
 case 22:
  boneLoc=P.GetBoneCoords('Bip01 L Calf').Origin;
  boneRot=P.GetBoneRotation('Bip01 L Calf');
   break;
 case 23:
  boneLoc=P.GetBoneCoords('Bip01 L Foot').Origin;
  boneRot=P.GetBoneRotation('Bip01 L Foot');
   break;
 case 24:
  boneLoc=P.GetBoneCoords('Bip01 L Toe0').Origin;
  boneRot=P.GetBoneRotation('Bip01 L Toe0');
   break;
 case 25:
  boneLoc=P.GetBoneCoords('Bip01 Head').Origin;
  boneRot=P.GetBoneRotation('Bip01 Head');
  break;
 }
}

//cleanup
event Destroyed()
{
if (E!=None)
  E.Destroy();
}

//two part loading, first create Emitter and Particles, then fill Emitter with Information
function LoadProp()
{
LoadPropOne();
SetTimer(loadTimeOut,false);
}

//second step
event Timer()
{
LoadPropTwo();
}


//load data, clean up and create new ParticleSystem
function LoadPropOne()
{
local MSBBlockCloud cloud;

cloud=Level.Game.LoadDataObject(class'MSBBlockCloud',content,"MSBDrawing_"$content);
//cleanUp
if (E!=None)
  E.Destroy();
E=Spawn(class'MSBEmitter',self,,Location,Rotation);
E.bHardAttach=true;
AttachToBone(E,'');
E.P.SpawnParticle(cloud.BlockRelLocation.Length);
}


//fill particle system with Information
function LoadPropTwo()
{
local MSBBlockCloud cloud;
local int block;
local color myColor;

cloud=Level.Game.LoadDataObject(class'MSBBlockCloud',content,"MSBDrawing_"$content);

for (block=0;block<cloud.BlockRelLocation.length;block++)
  {
  E.P.Particles[block].Location=cloud.BlockRelLocation[block];
    //color
  myColor=cloud.Col[block];
  E.P.Particles[block].ColorMultiplier.X=float(myColor.R)/255;
  E.P.Particles[block].ColorMultiplier.Y=float(myColor.G)/255;
  E.P.Particles[block].ColorMultiplier.Z=float(myColor.B)/255;
  E.P.Opacity=cloud.Opacity;
    //drawStyle
  E.P.DrawStyle=EParticleDrawStyle(cloud.DrawStyle);
    //size
  E.P.Particles[block].StartSize.X=cloud.drawScale[block];
  }
}

defaultproperties
{
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonAttachToBone"
Properties(5)="Dummy"
ButtonMat(5)="MoviesandboxTextures.icon_attach"

DrawType=DT_StaticMesh
Skins(0)=Material'MoviesandboxTextures.transBlack'
Skins(1)=Material'MoviesandboxTextures.red'
Skins(2)=Material'MoviesandboxTextures.transBlack'
StaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.CubeWhiteSided'
bStatic=false
bNoDelete=false
bHidden=false
drawScale=2
AmbientGlow=16
bDisplayed=true
bCollideActors=false
bCalcLighting=false
CollisionHeight=8
CollisionRadius=8
bFaceBlock=false
Tag='special'

loadTimeOut=0.5

//stepConst=0.07
//stepVar=1
}
