class MSBRDPuppetInputControl extends Actor;

var MSBRagDollPuppet myPuppet;

var MSBUdpLink udpLinkFeet;
var MSBUdpLink udpLinkHead;
var MSBUdpLink udpLinkHands;


var () int iPort;   // server port number
var bool bUdpInit;

var () vector leftDown, rightUp, leftDownTwo, rightUpTwo;   // hand constraints

var () vector bodyPos,                                      //body position variables
              leftFootPos,
              rightFootPos,
              leftHandPos,
              rightHandPos;

var () vector leftHandIn,
              rightHandIn;

var () float baseHandDistance;                                     //distance from hands to body
var () float baseClavDistance;                                       //factor from arm to clavicle

var () rotator bodyRot;                                     //body rotation

var () int activeFoot,                                   //the currently active foot
           stepheight,
           baseFootDistance;                                   //foot must get higher than this in order to become active

var () vector gametrakOffset;                            //if gametrak hangs upside down, this is the "floor" level

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBRagdollPuppet'))
  myPuppet=MSBRagdollPuppet(Owner);
}

function initFeetUdp()
{
 iPort=31840+myPuppet.UdpFeetPadCh;
 if (udpLinkFeet!=None)
   udpLinkFeet.Destroy();
 if (myPuppet.UdpFeetPadCh>0)
   {
   udpLinkFeet=Spawn(class'MSBUdpLink',self);
   udpLinkFeet.InitUdpLink(iPort);
   Log("UdpPort initialized to"@iPort);
   }
 else
   Log("udpLinkFeet destroyed");
}

function initHeadUdp()
{
 iPort=31840+myPuppet.UdpHeadPadCh;
 if (udpLinkHead!=None)
   udpLinkHead.Destroy();
 if (myPuppet.UdpHeadPadCh>0)
   {
   udpLinkHead=Spawn(class'MSBUdpLink',self);
   udpLinkHead.InitUdpLink(iPort);
   Log("UdpHeadPort initialized to"@iPort);
   }
}

function initHandsUdp()
{
 iPort=31840+myPuppet.UdpHandsPadCh;
 if (udpLinkHands!=None)
   udpLinkHands.Destroy();
 if (myPuppet.UdpHandsPadCh>0)
   {
   udpLinkHands=Spawn(class'MSBUdpLink',self);
   udpLinkHands.InitUdpLink(iPort);
   Log("UdpHandsPort initialized to"@iPort);
   }
}

event Trigger(Actor Other,Pawn EventInstigator)
{
//general data stuff
local vector pOne,X,Y,Z, newNeckLoc;

//feet and Walking
if (Other.IsA('MSBGuiOverlay'))
  {
  initFeetUdp();
  initHeadUdp();
  initHandsUdp();
  Log("changed UdpPadChannel in MSBRDPuppetInputControl!");
  }

//udp GameTrak_

//cleanup
//now with sin according to bodyRot

//********************************************
// Hands
if (myPuppet!=None && Other.IsA('MSBUdpLink') && myPuppet.bRunning)
  {
//*******************************************
//whole body

  updateBody();

//********************************************
// Hands

  myPuppet.GetAxes(bodyRot*(-1)+myPuppet.Rotation,X,Y,Z);     //rot (65536,65536,65536)-

  if (udpLinkHands!=None)
      {
      //calculate Gametrak positions from rotation
      pOne=gameTrakOffset-calcGTInput(UdpLinkHands.byteData[6],UdpLinkHands.byteData[7],UdpLinkHands.byteData[8],UdpLinkHands.byteData[9],UdpLinkHands.byteData[10],UdpLinkHands.byteData[11]);
      leftHandIn=pOne*vect(-1,-1,1)+vect(-4,-12,-24);//initial hand setup

      pOne=gameTrakOffset-calcGTInput(UdpLinkHands.byteData[0],UdpLinkHands.byteData[1],UdpLinkHands.byteData[2],UdpLinkHands.byteData[3],UdpLinkHands.byteData[4],UdpLinkHands.byteData[5]);
      rightHandIn=pOne*vect(-1,-1,1)+vect(-4,12,-24);//initial hand setup

      //confineHands(); //boundaries

      //movements relative to rotation
      leftHandIn=-leftHandIn.X*X-leftHandIn.Y*Y+leftHandIn.Z*Z;
      rightHandIn=-rightHandIn.X*X-rightHandIn.Y*Y+rightHandIn.Z*Z;
      }
   updateHands();
//********************************************
// Feet

  myPuppet.GetAxes(bodyRot*(-1) + myPuppet.Rotation,X,Y,Z);  //
//  myPuppet.GetAxes(bodyRot+myPuppet.Rotation,X,Y,Z);

  //calculate Gametrak positions from rotation
  if (udpLinkFeet!=None)
    {
    myPuppet.rightFootLoc=gameTrakOffset-calcGTInput(UdpLinkFeet.byteData[6],UdpLinkFeet.byteData[7],UdpLinkFeet.byteData[8],UdpLinkFeet.byteData[9], UdpLinkFeet.byteData[10], UdpLinkFeet.byteData[11]);
    myPuppet.leftFootLoc=gameTrakOffset-calcGTInput(UdpLinkFeet.byteData[0],UdpLinkFeet.byteData[1],UdpLinkFeet.byteData[2],UdpLinkFeet.byteData[3], UdpLinkFeet.byteData[4], UdpLinkFeet.byteData[5]);

    //make relative
    myPuppet.leftFootLoc=myPuppet.leftFootLoc.X*X-myPuppet.leftFootLoc.Y*Y+myPuppet.leftFootLoc.Z*Z;
    myPuppet.rightFootLoc=myPuppet.rightFootLoc.X*X-myPuppet.rightFootLoc.Y*Y+myPuppet.rightFootLoc.Z*Z;
    myPuppet.leftFootLoc+=leftFootPos;
    myPuppet.rightFootLoc+=rightFootPos;

    stepFeet();
    }
//***********************************
//Head

  if (udpLinkHead!=None)
      {
      //Head itself
      pOne.X=-25;
      pOne.Y=udpLinkHead.byteData[0]-128;
      pOne.Z=-(udpLinkHead.byteData[1]-128);
      newNeckLoc=Normal(pOne)*25 << bodyRot;

      newNeckLoc=-newNeckLoc.X*X-newNeckLoc.Y*Y+newNeckLoc.Z*Z;
      myPuppet.neckLoc+=newNeckLoc;

      //grab
      myPuppet.bGrabRight=bool(udpLinkHead.byteData[4]);
      myPuppet.bGrabLeft=bool(udpLinkHead.byteData[3]);

      //Body rotate
      pOne.X=-udpLinkHead.byteData[7];
      pOne.Y=udpLinkHead.byteData[8];
      pOne.Z=0;
      bodyRot.Yaw+=pOne.X*400+pOne.Y*400;
      //Body up-down
      pOne.X=udpLinkHead.byteData[9];
      pOne.Y=-udpLinkHead.byteData[10];
      pOne.Z=0;
      bodyPos.Z+=pOne.X+pOne.Y;

      }
  }
}

event Destroyed()
{
if (udpLinkFeet!=None)
  udpLinkFeet.Destroy();
if (udpLinkHands!=None)
  udpLinkHands.Destroy();
if (udpLinkHead!=None)
  udpLinkHead.Destroy();
}

function updateBody()
{
myPuppet.neckLoc=bodyPos;
myPuppet.spineLoc=bodyPos;

myPuppet.leftClavLoc.X=-baseClavDistance*sin(float(bodyRot.Yaw)*Pi/32768);
myPuppet.leftClavLoc.Y=baseClavDistance-baseClavDistance*cos(float(bodyRot.Yaw)*Pi/32768);
myPuppet.leftClavLoc.Z=0;

myPuppet.rightClavLoc.X=baseClavDistance*sin(float(bodyRot.Yaw)*Pi/32768);
myPuppet.rightClavLoc.Y=baseClavDistance*cos(float(bodyRot.Yaw)*Pi/32768)-baseClavDistance;
myPuppet.rightClavLoc.Z=0;

myPuppet.leftClavLoc+=bodyPos;
myPuppet.rightClavLoc+=bodyPos;

//feet different!
myPuppet.leftFootLoc=leftFootPos;
myPuppet.rightFootLoc=rightFootPos;
}

function updateHands()
{
//right Hand
//rotate overall null-point
rightHandPos.X=baseHandDistance*sin(float(bodyRot.Yaw)*Pi/32768);
rightHandPos.Y=baseHandDistance*cos(float(bodyRot.Yaw)*Pi/32768)-baseHandDistance;
//bring everytihng together
myPuppet.rightHandLoc=rightHandPos+rightHandIn+bodyPos;

//left Hand
//rotate overall null-point
leftHandPos.X=-baseHandDistance*sin(float(bodyRot.Yaw)*Pi/32768);
leftHandPos.Y=baseHandDistance-baseHandDistance*cos(float(bodyRot.Yaw)*Pi/32768);
//bring everytihng together
myPuppet.leftHandLoc=leftHandPos+leftHandIn+bodyPos;
}

function Reset()
{
super.Reset();

bodyPos=vect(0,0,0);
bodyRot=rot(0,0,0);
leftFootPos=vect(0,0,0);
rightFootPos=vect(0,0,0);
leftHandPos=vect(0,0,0);
rightHandPos=vect(0,0,0);
myPuppet.leftClavLoc=vect(0,0,0);
myPuppet.rightClavLoc=vect(0,0,0);
myPuppet.leftHandLoc=vect(0,0,0);
myPuppet.rightHandLoc=vect(0,0,0);
}

//calculate Gametrak positions from rotation
function vector calcGTInput(byte y1,byte y2 ,byte p3,byte p4, byte x5,byte x6)
{
local vector pOne;
local rotator offset, pOneRot;
local float dataOne, pOneLength;

offset.Pitch=16384;
dataOne=(y1 << 8)+ y2 - 32767;
dataOne=(dataOne/32768)*8192; //45 degrees in unreal coordinates
pOneRot.Yaw=dataOne;

dataOne=(p3 << 8)+ p4 - 32767;
dataOne=(dataOne/32768)*8192; //45 degrees in unreal coordinates
pOneRot.Pitch=dataOne;

//leftFoot
pOneLength=65536-((x5 << 8) + x6);
pOne=vector(pOneRot)*((pOneLength/255));
pOne=pOne >> offset;
return pOne;
}

function stepFeet()
{
local vector deltaFeet;

// determine active step and active foot
// when foot is lowered below threshhold again, step is finished
if (activeFoot==0)
    {
    myPuppet.leftFootLoc.X=leftFootPos.X;
    myPuppet.leftFootLoc.Y=leftFootPos.Y;

    myPuppet.rightFootLoc.X=rightFootPos.X;
    myPuppet.rightFootLoc.Y=rightFootPos.Y;
    }

if (activefoot==1)
    {
    myPuppet.leftFootLoc=leftFootPos;
    if (myPuppet.rightFootLoc.Z<stepHeight)
      {
      rightFootPos.X=myPuppet.rightFootLoc.X;
      rightFootPos.Y=myPuppet.rightFootLoc.Y;
      activeFoot=0;
      }
    }
if (activefoot==-1)
    {
    myPuppet.rightFootLoc=rightFootPos;
    if (myPuppet.leftFootLoc.Z<stepHeight)
      {
      leftFootPos.X=myPuppet.leftFootLoc.X;
      leftFootPos.Y=myPuppet.leftFootLoc.Y;
      activeFoot=0;
      }
    }

// if foot is lifted above threshhold, foot becomes active.
if (myPuppet.rightFootLoc.Z>stepHeight) activeFoot=1;
if (myPuppet.leftFootLoc.Z>stepHeight) activeFoot=-1;

// Body = in between Feet
deltaFeet.X=Abs(myPuppet.rightFootLoc.X-myPuppet.leftFootLoc.X);
deltaFeet.Y=Abs(baseFootDistance-myPuppet.rightFootLoc.Y+myPuppet.leftFootLoc.Y);

//always relative to last footstep
if (myPuppet.rightFootLoc.X>myPuppet.leftFootLoc.X)
  bodyPos.X=deltaFeet.X/2 + myPuppet.leftFootLoc.X;
else
  bodyPos.X=deltaFeet.X/2 + myPuppet.rightFootLoc.X;

bodyPos.Y=deltaFeet.Y/2 + myPuppet.leftFootLoc.Y;

//TODO:
//here we can turn!!!
//deltaFeet=deltaFeet cross vect(0,0,1);
//bodyRot.yaw=(rotator(deltaFeet).Yaw-32768)/2;
}


defaultproperties
{
leftDown=(X=-32,Y=-36,Z=-12)
rightUp=(X=0,Y=6,Z=54)
leftDownTwo=(X=-32,Y=-6,Z=-12)
rightUpTwo=(X=0,Y=36,Z=54)

DrawType=DT_None
iPort=31840
gametrakOffset=(X=0,Y=0,Z=65);
stepHeight=14
baseHandDistance=34
baseClavDistance=10
baseFootDistance=-14
//bContactingLevel!!!!
}
