//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBRagDollPuppet extends MSBActor;

const points=26;
var MSBRagdoll Puppet;
var MSBKActor PuppetControl[points];
var MSBKBSJoint Glue[points];
var Sound clapSound;
var bool bClapped;
var vector initialPuppetLocation;
var vector initialControlLocs[points];
var rotator initialPuppetRotation;
var KSimParams initialKSim;
var KRigidBodyState initialRBState, currentRBState;
var int maxControlPoints;
var vector leftHandLoc,
           rightHandLoc,
           rightFootLoc,
           leftFootLoc,
           neckLoc,
           spineLoc,
           leftClavLoc,
           rightClavLoc;

var bool bRunning;
var int UdpFeetPadCh, UdpHeadPadCh, UdpHandsPadCh;
var bool bGrabLeft,bGrabRight;

event PostBeginPlay()
{
local int i;

super.PostBeginPlay();

//create the Puppet
Puppet=Spawn(class'MSBRagdoll',self,,Location,Rotation);

Puppet.KGetRigidBodyState(initialRBState);
//Puppet.KGetSimParams(initialKSim);
//initialKSim.Epsilon+=1;
//initialKSim.MaxTimestep=0;
//Puppet.KSetSimParams(initialKSim);


//create the PuppetControls
for (i=0;i<maxControlPoints;i++)
  {
  PuppetControl[i]=Spawn(class'MSBKActor',self,,Location,Rotation);
  PuppetControl[i].Mass=1;
  Glue[i]=Spawn(class'MSBKBSJoint',self,,Location,Rotation);
  Glue[i].KConstraintActor1=Puppet;
  Glue[i].KConstraintActor2=PuppetControl[i];
  }
AttachBoneStuff();
}

function LoadProp()
{
Log("trying to load:"@content);
puppet.content=content;
puppet.LoadProp();
}

function Tick(float DeltaTime)
{
//0=leftHand
//1=rightHand


if (bRunning && PuppetControl[2]!=None)
  {
//  for (i=0;i<maxControlPoints;i++)
//  PuppetControl[i].bHidden=false;

  PuppetControl[0].loc=leftHandLoc;
  PuppetControl[1].loc=rightHandLoc;

  PuppetControl[0].bGrab=bGrabLeft;
  if (!bGrabLeft && PuppetControl[0].myGrabbedThing!=None)
    {
    PuppetControl[0].myGrabbedThing.SetLocation(PuppetControl[0].myGrabbedThing.initialLocation);
    PuppetControl[0].myGrabbedThing=None;
    }

  PuppetControl[1].bGrab=bGrabRight;
  if (!bGrabRight && PuppetControl[1].myGrabbedThing!=None)
    {
    PuppetControl[1].myGrabbedThing.SetLocation(PuppetControl[1].myGrabbedThing.initialLocation);
    PuppetControl[1].myGrabbedThing=None;
    }

  PuppetControl[2].loc=neckloc;

  PuppetControl[3].loc=spineLoc;
  PuppetControl[4].loc=spineLoc;

  PuppetControl[5].loc=rightClavLoc;
  PuppetControl[6].loc=leftClavLoc;

  PuppetControl[7].loc=leftFootLoc;
  PuppetControl[8].loc=rightFootLoc;
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
if (Other.IsA('MSBGuiOverlay'))
  MSBInputControl.Trigger(Other,None);
}

function RunMovie()
{
local int i;

super.RunMovie();
self.DetachFromBone(Puppet);
initialPuppetLocation=Puppet.Location;
Puppet.SetPhysics(PHYS_KarmaRagDoll);

for (i=0;i<maxControlPoints;i++)
  {
  PuppetControl[i].SetPhysics(PHYS_Karma);
  Glue[i].SetPhysics(PHYS_Karma);
  PuppetControl[i].TriggerEvent('RunMovie',self,None);
  PuppetControl[i].bHidden=true;
  }

bRunning=true;
SetCollision(false,false);
}

function Reset()
{
local int i;
local vector initialLoc;
local rotator initialRot;
super.Reset();

bRunning=false;

for (i=0;i<maxControlPoints;i++)
  {
  PuppetControl[i].loc=vect(0,0,0);
  PuppetControl[i].SetPhysics(PHYS_None);
  PuppetControl[i].bHidden=false;
  Glue[i].SetPhysics(PHYS_None);
  Glue[i].bHidden=false;
  }

SetCollision(true,false);

initialLoc=Location;
initialRot=Rotation;

Puppet.clearPawn();
Puppet.Destroy();

Puppet=Spawn(class'MSBRagdoll',self,,initialLoc,initialRot);
Puppet.KGetSimParams(initialKSim);
Puppet.KGetRigidBodyState(initialRBState);

//create the PuppetControls
for (i=0;i<maxControlPoints;i++)
  {
  Glue[i].KConstraintActor1=Puppet;
  Glue[i].KConstraintActor2=PuppetControl[i];
  }
AttachBoneStuff();
puppet.setMSBMasterBlocks();
puppet.content=content;
puppet.loadProp();
MSBInputControl.Reset();
}

function releaseStrings()
{
local int i;
for (i=0;i<points;i++)
  {
  PuppetControl[i].loc=vect(0,0,0);
  PuppetControl[i].SetPhysics(PHYS_None);
//  PuppetControl[i].bHidden=false;
  Glue[i].SetPhysics(PHYS_None);
//  Glue[i].bHidden=false;
  }
}

function reAttachStrings()
{
local int i;

AttachBoneStuff();
for (i=0;i<maxControlPoints;i++)
  {
  Glue[i].KConstraintActor1=Puppet;
  Glue[i].KConstraintActor2=PuppetControl[i];
  }
SetTimer(0.2,false);
}

event Timer()
{
local int i;
for (i=0;i<maxControlPoints;i++)
  {
  PuppetControl[i].Reset();
  PuppetControl[i].SetPhysics(PHYS_Karma);
  Glue[i].SetPhysics(PHYS_Karma);
  }
}

function AttachBoneStuff()
{
self.AttachToBone(Puppet,'');

Puppet.AttachToBone(Glue[0],'Bip01 L Hand');
Puppet.AttachToBone(PuppetControl[0],'Bip01 L Hand');

Puppet.AttachToBone(Glue[1],'Bip01 R Hand');
Puppet.AttachToBone(PuppetControl[1],'Bip01 R Hand');
//add grabbing functionality
//PuppetControl[1].Grab=true;

Puppet.AttachToBone(Glue[2],'Bip01 Head');
Puppet.AttachToBone(PuppetControl[2],'Bip01 Head');
Glue[2].SetRelativeLocation(vect(0,-25,0));
PuppetControl[2].SetRelativeLocation(vect(0,-50,0));

Puppet.AttachToBone(Glue[3],'Bip01 Spine');
Puppet.AttachToBone(PuppetControl[3],'Bip01 Spine');

Puppet.AttachToBone(Glue[4],'Bip01 Spine2');
Puppet.AttachToBone(PuppetControl[4],'Bip01 Spine2');

Puppet.AttachToBone(Glue[5],'Bip01 R Clavicle');
Puppet.AttachToBone(PuppetControl[5],'Bip01 R UpperArm');

Puppet.AttachToBone(Glue[6],'Bip01 L Clavicle');
Puppet.AttachToBone(PuppetControl[6],'Bip01 L UpperArm');

Puppet.AttachToBone(Glue[7],'Bip01 L Foot');
Puppet.AttachToBone(PuppetControl[7],'Bip01 L Foot');
Glue[7].SetRelativeLocation(vect(0,10,0));
PuppetControl[7].SetRelativeLocation(vect(0,20,0));

Puppet.AttachToBone(Glue[8],'Bip01 R Foot');
Puppet.AttachToBone(PuppetControl[8],'Bip01 R Foot');
Glue[8].SetRelativeLocation(vect(0,10,0));
PuppetControl[8].SetRelativeLocation(vect(0,20,0));

}

event Destroyed()
{
local int i;
for (i=0;i<maxControlPoints;i++)
  {
  Glue[i].Destroy();
  PuppetControl[i].Destroy();
  Puppet.clearPawn();
  if (Puppet!=None)
    Puppet.Destroy();
  }
MSBInputControl.Destroy();
}

function clearActor()
{
Puppet.clearPawn();
}

DefaultProperties
{
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(3)="UdpFeetPadCh"
ButtonMat(3)="MoviesandboxTextures.icon_puppet"

ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(4)="UdpHandsPadCh"
ButtonMat(4)="MoviesandboxTextures.icon_puppet2"

ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(5)="UdpHeadPadCh"
ButtonMat(5)="MoviesandboxTextures.icon_puppet2"

CollisionRadius=32.0
CollisionHeight=32.0
bInputControlled=true
InputControlClassName="MSBObjects.MSBRDPuppetInputControl"
bDisplayed=false

clapSound=Sound'PlayerSounds.BFootstepWood2'
maxControlPoints=9
}
