//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonLoadPartsList extends MSBPropertyButtonComplex;

function fillButtonList()
{
local int i;

for (i=0;i<M.SaveCharParts.length;i++)
  {
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
  ButtonName[i]=M.SaveCharParts[i];
  }
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local int i;

for (i=0;i<ListButton.length;i++)
  if (Other==ListButton[i])
    {
    if (Parent.IsA('MSBMasterBlock'))
      LoadPart(MSBMasterBlock(Parent),i);
    }
}

function LoadPart(MSBMasterBlock Master, int Part)
{
local MSBBlockCloud cloud;
local int i,sps;
local class <MSBVoxelShader> shaderclass;
local string loadName;

//get rid of old blocks
loadname=M.SaveCharParts[Part];
Master.clearBlocks();
cloud=Level.Game.LoadDataObject(class'MSBBlockCloud',loadName,"MSBVoxPart_"$loadName);
for (i=0;i<cloud.Col.length;i++)
  {
  Master.S[i]=Spawn(class'MSBsimpleBlock',,,Master.Location);
  Master.S[i].bEdit=true;
  Master.S[i].SetDrawScale(cloud.drawScale[i]);
  Master.S[i].Skins[0]=new() class'ColorModifier';
  ColorModifier(Master.S[i].Skins[0]).Color=cloud.Col[i];
  ColorModifier(Master.S[i].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
  Master.AttachToBone(Master.S[Master.S.length-1],'');
  Master.S[i].SetRotation(Master.Rotation);
  Master.S[i].setRelativeLocation(cloud.BlockRelLocation[i]);// >> Master.Rotation);
  Master.S[i].Master=Master;
  if (cloud.blockShader[i]!="")
    {
    shaderClass=class<MSBVoxelShader>(DynamicLoadObject(cloud.blockShader[i],class'Class'));
    Master.S[i].shader= new shaderClass;
    Master.S[i].shader.Parent=Master.S[i];
    Master.S[i].shader.originalDrawScale3D=Master.S[i].DrawScale3D;
    for (sps=0;sps<Master.S[i].shader.Properties.length;sps++)
      Master.S[i].shader.SetPropertyText(Master.S[i].shader.Properties[sps],cloud.blockShaderValues[sps]);
    Log(Master.S[i].shader);
    }
  }
}


DefaultProperties
{
Col=(R=128,G=64,B=64)
maxListSize=10
}
