//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBTraceCharacterButton extends MSBPropertyButtonComplex
config (MSBCode);

//helping hands
var MSBVoxelEdController CC;
var MSBUdpLink udpLink;
var float stepsX, stepsY;

//stuff to adjust
var () config float brushSize;
var () config float depthSize;
var () float setBone;
var () vector startLoc;

//stuff from outside
var int resolution;                                   //determines the number of steps per line
var int boneValue;                                    //determines which bone to link to
var byte red,green,blue, alpha, zValue;

function Trigger(Actor Other, Pawn EventInstigator)
{
if (Other==ListButton[ListButton.length-1])
  {
  Reset();
  CC=MSBVoxelEdController(M);
  if(udpLink==None)
    {
    udpLink= spawn(class'MSBUdpLink',self);
    udpLink.InitUdpLink(41840);
    }
  SaveConfig();
  }

if(Other==udpLink)
  {
  //get outside data
  alpha= udpLink.byteData[0];
  red=udpLink.byteData[1];
  green=udpLink.byteData[2];
  blue=udpLink.byteData[3];
  zValue=udpLink.byteData[4];
  resolution=udpLink.byteData[5]+1;
  boneValue=udpLink.byteData[6];

  //do trace
  DoTrace();
  }
}

function DoTrace()
{
local vector currentLoc;
local color newCol;
local float factor;

//start traversing the ruler from top left to bottom right
if (stepsX>=resolution)
  {
  stepsY+=1;
  stepsX=0;
  }

//debug
CC.debugString=stepsx@stepsY;
//set Brush Properties
//location
factor=128/resolution;
currentLoc.Z=(stepsX*factor)-startloc.Z;
currentLoc.Y=(stepsY*factor)-startloc.Y;
currentLoc.X=startloc.X+float(zValue)/depthSize;
CC.DrawBrush.SetLocation(currentLoc);

//color
newCol.R=red;
newCol.G=green;
newCol.B=blue;
CC.DrawBrush.myColor=newCol;

//size
CC.DrawBrush.SetDrawScale(brushSize);

if(zValue>0)
  {
  //paint
  if(setBone==0)
    {
//    if (boneValue==0)
//      CC.determineMaster(currentLoc);
//    else
//      {
      CC.bMasterSelectionControlled=true;
      CC.drawBrush.Master=CC.myReferencePawn.Blocks[boneValue];
//      }
    }
  else
    CC.drawBrush.Master=CC.myReferencePawn.Blocks[setBone];
  CC.DrawBrush.draw();
  }

stepsX+=1;
}

function Reset()
{
stepsX=0;
stepsY=0;
}

DefaultProperties
{
ButtonList(0)="MSBPropertyButtons.MSBPropertyButtonText"
ButtonProperty(0)="brushSize"
ButtonName(0)="brushSize"

ButtonList(1)="MSBPropertyButtons.MSBPropertyButtonText"
ButtonProperty(1)="depthSize"
ButtonName(1)="depthSize"

ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonText"
ButtonProperty(2)="setBone"
ButtonName(2)="depthSize"

ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonAssign"
ButtonProperty(3)=""
ButtonName(3)="Start!"

tooltip1="Set Master Block"
tooltip2="Select Master Block"
BtnName="Trace"
bMainMenu=true
listOrientation=2
widthRel=64
heightRel=64

boneValue=1


depthSize=8
brushSize=0.125
startLoc=(X=108,Y=64,Z=64) //based from normrulerVect
}
