//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdFullSaveButton extends MSBPropertyButtonComplex;

var MSBVoxelEdController CC;
var string saveName;

event PostBeginPlay()
{
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
Parent=self;
}

function createButtons()                      //spawns subButtons
{
local int i;

for (i=0;i<M.saveCharacters.length+1;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonText";

super.createButtons();

for (i=0;i<ListButton.length;i++)
  {
    MSBPropertyButton(ListButton[i]).Property="saveName";
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName="createNew";
    if (liststart+i<ButtonList.length-1)
      MSBPropertyButton(ListButton[i]).BtnName=M.SaveCharacters[liststart+i];
  }
}


event Trigger(Actor Other, Pawn EventInstigator)
{
local MSBVoxelCharacterSave char;
local MSBMasterBlock Master;
local int i,bone, block;
local color myColor;

super.Trigger(Other, EventInstigator);

if(!Other.IsA('MSBScrollBar'))
  {
Master=CC.DrawBrush.Master;
char=Level.Game.CreateDataObject(class'MSBVoxelCharacterSave',saveName,"MSBVoxChar_"$saveName);

//block/Voxel related
for (bone=0;bone<CC.myReferencePawn.Blocks.length;bone++)
  {
  char.Parts.Insert(bone,1);
  Master=CC.myReferencePawn.Blocks[bone];
  if (Master!=None && Master.E!=None)
   {
   for (block=0;block<Master.E.P.activeParticles;block++)
    {
    //location
    char.Parts[bone].BlockRelLocation[block]=Master.E.P.Particles[block].Location;
    //color
    myColor.R=Master.E.P.Particles[block].ColorMultiplier.X*255;
    myColor.G=Master.E.P.Particles[block].ColorMultiplier.Y*255;
    myColor.B=Master.E.P.Particles[block].ColorMultiplier.Z*255;
    char.Parts[bone].Col[block]=myColor;
    //size
    char.Parts[bone].drawScale[block]=Master.E.P.Particles[block].StartSize.X;
    }
   }
  }

for (bone=0;bone<CC.myReferencePawn.FaceBlocks.length;bone++)
  {
  char.Face.Insert(bone,1);
  Master=CC.myReferencePawn.FaceBlocks[bone];
  if (Master!=None && Master.E!=None)
   {
   for (block=0;block<Master.E.P.activeParticles;block++)
    {
    //location
    char.Face[bone].BlockRelLocation[block]=Master.E.P.Particles[block].Location;
    //color
    myColor.R=Master.E.P.Particles[block].ColorMultiplier.X*255;
    myColor.G=Master.E.P.Particles[block].ColorMultiplier.Y*255;
    myColor.B=Master.E.P.Particles[block].ColorMultiplier.Z*255;
    char.Face[bone].Col[block]=myColor;
    //size
    char.Face[bone].drawScale[block]=Master.E.P.Particles[block].StartSize.X;
    }
   }
  }

Level.Game.SavePackage("MSBVoxChar_"$saveName);

//update SaveCharacters List
/*update SaveGame List:
everytime we save a game we check if a similar name already exists in our savegame list.
If so, we delete it from the list and put it back in at position 0.
*/

for (i=0;i<M.SaveCharacters.length;i++)
  if (M.SaveCharacters[i]==saveName)
    M.SaveCharacters.Remove(i,1);

for (i=0;i<ListButton.Length;i++)
  if (Other==ListButton[i])
    {
    M.SaveCharacters.Insert(0,1);
    M.SaveCharacters[0]=saveName;
    }

M.SaveGeneralConfig();
Mouse.deSelectAll();
  }
}


DefaultProperties
{
tooltip="Save a Full Character"
Mat=Texture'MoviesandboxTextures.icon_save'
maxListSize=12
col=(R=255,G=255,B=255)
widthRel=30
heightRel=30
listOrientation=2
}
