class MSBPropertyButtonSetShader extends MSBPropertyButtonComplex;

var string shaderName;
var class<MSBVoxelShader> ShaderClass;
var MSBVoxelShader myShader;
var MSBVoxelEdController CC;
var array<string> Values;
var bool bSetAll;


function LeftBtn(Canvas C)
{
local int list;

CC=MSBVoxelEdController(M);

if (Property!="None")
  {
    //generate default Shader to fill ButtonList
    ShaderClass=class<MSBVoxelShader>(DynamicLoadObject(Property,class'Class',true));
    myShader=new ShaderClass;

    for (list=0;list<myShader.Properties.length;list++)
      {
      ButtonList[list]="MSBPropertyButtons.MSBPropertyButtonText";
      ButtonProperty[list]=myShader.Properties[list];
      ButtonName[list]=myShader.Properties[list];
      }
  }
ButtonList[list]="MSBPropertyButtons.MSBPropertyButtonAssign";
ButtonProperty[list]="";
ButtonName[list]="Assign!";

super.LeftBtn(C);

if (Property!="None")
  for (list=0;list<myShader.Properties.length;list++)
    {
    MSBPropertyButton(ListButton[list]).Value="";
    Values[list]=myShader.GetPropertyText(myShader.Properties[list]);
    MSBPropertyButton(ListButton[list]).Value=Values[list];
    Log(MSBPropertyButton(ListButton[list]).Value@myShader.GetPropertyText(myShader.Properties[list]));
    MSBPropertyButton(ListButton[list]).bVaporiseValue=false;
    }
}

function Trigger(Actor Other, Pawn EventInstigator)
{
local int i;

if (Other.IsA('MSBPropertyButton') && !Other.IsA('MSBPropertyButtonAssign'))
  {
  Log("We have been triggered!!");
  //got a Property Assigned - reassign to our Value array!
  for (i=0;i<myShader.properties.length;i++)
    if(Other==ListButton[i])
      Values[i]=MSBPropertyButton(ListButton[i]).Value;
    Log(Values[0]);
  }
if (Other==ListButton[ListButton.length-1])
  {
  if (bSetAll)
    for (i=0;i<CC.myReferencePawn.Blocks.length;i++)
      SetShader(CC.myReferencePawn.Blocks[i]);
  else
    SetShader(MSBMasterBlock(Parent));
  }
}

function SetShader(MSBMasterBlock Master)
{
local int i, list;

CC=MSBVoxelEdController(M);

Log("setting Shaders..."@Master.S.length);

for (i=0;i<Master.S.length;i++)
  {
  if (Property!="None")
    {
    //getting rid of old shader
    if (Master.S[i].shader!=None)
      {
      //check if we did an extrusion/location conversion before
      //and adjust the location appropriately
      if (hasBeenExtruded(Master.S[i]))
        Master.S[i].iniRelLocation.X*=1/1.5;
      //Reset the Drawscale and remove the old shader
      Master.S[i].shader.Reset();
      Master.S[i].shader=none;
      }

    //create a new Shader for each object
    myShader=new ShaderClass;

    //we will now set the shader Properties
    for (list=0;list<myShader.properties.length;list++)
      {
      myShader.SetPropertyText(myShader.Properties[list],Values[list]);
      Log("Setting"@myShader.Properties[list]@"to"@Values[list]);
      }
    Master.S[i].shader=myShader;
    Master.S[i].shader.Parent=Master.S[i];

    //We need to check if our Blocks come from a Trace or from Drawing.
    //Traced Blocks are extruded and need to be "converted" to position data
    //for the shader sprites to make sense!

    //We need to bring the blocks back to their original Position if the shader before us
    //converted between extrusion and location
    if (Master.S[i].shader.bSwitchExtrusion)
      {
      Master.S[i].shader.originalDrawScale3D=Master.S[i].DrawScale3D;
      checkExtrude(Master.S[i]);
      }
    //we don't have to do anything in this case...
    //if (!Master.S[i].shader.bSwitchExtrusion && !bComingFromOldSwitchExtrusionShader)
    }
  else
    {
    //Reset to old Blocks
    if (Master.S[i].shader!=None)
      {
      //only if we converted from Extrusion - set to old block distance
      if (hasBeenExtruded(Master.S[i]))
        Master.S[i].iniRelLocation.X*=1/1.5;
      Master.S[i].shader.Reset();
      Master.S[i].shader=none;
      Log("Setting stuff back..."@Master.S[i]@Master.S[i].drawScale@Master.S[i].drawScale3D);
      }
    else //fallback if something went wrong...
      {
      Log(Master.S[i]@Master.S[i].drawScale@Master.S[i].drawScale3D);
      Master.S[i].SetDrawType(DT_StaticMesh);
      }
    }
  }
}

function bool hasBeenExtruded(Actor Parent)
{
return (Parent.DrawScale3D.X!=Parent.DrawScale3D.Y || Parent.DrawScale3D.X!=Parent.DrawScale3D.Z);
}

//used for converting extruded Brushes to positioned brushes...
function checkExtrude(MSBsimpleBlock Parent)
{
//check if we are an extruded Trace, so we have to adjust our Location
if (hasBeenExtruded(Parent))
  {
  Parent.iniRelLocation.X*=1.5;
  Parent.SetDrawScale3D(vect(1,1,1));
  }
}

defaultproperties
{
Property="MSBVoxelShader.MSBselfShader"
}
