class MSBPenInputControl extends Actor;

var MSBDrawBrush myBrush;
var MSBPenWidget pen;

var MSBUdpLink udpLinkLoc;
var MSBUdpLink udpLinkAct;

var () int iPort;   // server port number
var bool bUdpInit;
var () vector leftDown, rightUp, leftDownTwo, rightUpTwo;
var() float pointDist, moveScale;

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBPenWidget'))
  {
  pen=MSBPenWidget(Owner);
  myBrush=pen.DrawBrush;
  }
}

function initUdpLoc()
{
 iPort=31840+pen.channel;
 if (udpLinkLoc!=None)
   udpLinkLoc.Destroy();
 if (pen.channel>0)
   {
   udpLinkLoc=Spawn(class'MSBUdpLink',self);
   udpLinkLoc.InitUdpLink(iPort);
   Log("UdpPortLoc initialized to"@iPort);
   }
 else
   Log("udpLink destroyed");
}
function initUdpAct()
{
 iPort=31840+pen.channel+1;
 if (udpLinkAct!=None)
   udpLinkAct.Destroy();
 if (pen.channel+1>0)
   {
   udpLinkAct=Spawn(class'MSBUdpLink',self);
   udpLinkAct.InitUdpLink(iPort);
   Log("UdpPortAct initialized to"@iPort);
   }
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local rotator pOneRot, offset;
local float data, pOneLength;
local vector pOne;

if (Other.IsA('MSBGuiOverlay'))
  {
  initUdpLoc();
  initUdpAct();
  Log("changed UdpPadChannel in MSBPenInputControl!");
  }

//udp Gamepad_
if (myBrush!=None && pen.channel>0 && Other==udpLinkLoc)
  {
  offset.Pitch=16384;
  // *********************************************************  First Point
  data=(UdpLinkLoc.byteData[0] << 8)+ UdpLinkLoc.byteData[1] - 32768;
  data=(data/32768)*5461;
  pOneRot.Yaw=data;

  data=(UdpLinkLoc.byteData[2] << 8)+ UdpLinkLoc.byteData[3] - 32768;
  data=(data/32768)*5461;
  pOneRot.Pitch=-data;

  pOneLength=65536 -((UdpLinkLoc.byteData[4] << 8) + UdpLinkLoc.byteData[5]) ;
  pOne=vector(pOneRot)*((pOneLength/moveScale));
  pOne=pOne >> offset;
  if (myBrush!=None)
    myBrush.SetLocation(pen.Ruler.Location+pOne);

  data=(udpLinkAct.byteData[3]);
  if (data==1)
    pen.DrawBrush.draw();

  data=(udpLinkAct.byteData[4]);
  if (data==1)
    pen.DrawBrush.erase();
  }
}

event Destroyed()
{
udpLinkLoc.Destroy();
udpLinkAct.Destroy();
}

defaultproperties
{
DrawType=DT_None
iPort=31840

pointDist=64
moveScale=64
bHidden=true
}
